RSA_Version = 0.27;


RSA_Defaults = {
	["version"] = RSA_Version
};




local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded

function frame:OnEvent(event, arg1)
 if event == "ADDON_LOADED" and arg1 == "RSA" then
  -- Our saved variables are ready at this point. If there are none, both variables will set to nil.
  if _G.RSA_Defaults.version < RSA_Version then
	Print("Addon has been updated. Resetting default data.");
	_G.RSA_Defaults.version = RSA_Version
	_G.RSA_SPELL_TARGET = _G["RSA_SPELL_TARGET"]
-- ########## ADD THE TABLES LATER ON TO HERE INSTEAD. THIS CODE SHOULD ADD ALL VALUES TO THE 
-- ########## SAVEDVARIABLE FILE IF IT ISN'T THERE, SO NO POINT IN HAVING IT DOWN THERE WHEN 
-- ########## IT WILL BE NEEDED HERE ANYWAY. I THINK ANYWAY. JUST TRY IT. JUST DON'T FORGET THAT 
-- ########## IT'S BASED ON THE RSA_Version VARIABLE AT THE TOP. NEED TO MAKE IT ONE HIGHER FOR IT TO UPDATE.
-- ########## ONCE THIS WORKS, THEN I NEED TO CODE A CHECK SO THAT IT ONLY ADDS NEW STUFF, OR DELETES STUFF NO LONGER HERE.
-- ########## WE DON'T WANT TO RESET EVERYONE'S SETTINGS EACH TIME I UPDATE THE ADDON.
  end
end
end
frame:SetScript("OnEvent", frame.OnEvent);


--[[
if (ThisAddon_Options["version"] < ThisAddon_Version) then
  ThisAddon_Options_temp = ThisAddon_Defaults["Options"];
  for k,v in ThisAddon_Options do
    if (ThisAddon_Defaults["Options"][k]) then
      ThisAddon_Options_temp[k] = v;
    end
  end
  ThisAddon_Options_temp["version"] = ThisAddon_Version;
  ThisAddon_Options = ThisAddon_Options_temp;
end

]]--



--[[
function frame:OnEvent(event, arg1)
 if event == "ADDON_LOADED" and arg1 == "RSA" then
--  if (not RSA_Options) then
--    RSA_Options = RSA_Defaults["Options"];
--  end
if (RSA_Options["version"] < RSA_Version) then
  RSA_Options_temp = RSA_Defaults["Options"];
  for k,v in RSA_Options do
    if (RSA_Defaults["Options"][k]) then
      RSA_Options_temp[k] = v;
    end
  end
  RSA_Options_temp["version"] = RSA_Version;
  RSA_Options = RSA_Options_temp;
end
end
end
]]--


--rsa_v = "0.1"
--_G["Version"] = rsa_v;

--if _G["RSA_V"] < rsa_v then




--[[ Current Basic Configuration Options ]]--
local rsa_self = "player" -- Do not change.
local rsa_target = "target"
local rsa_mouseover = "mouseover"
local rsa_focus = "focus"

--[[ Localisation ]]-- 
local rsa_spell_cast = "%s on "
local rsa_buff_cast = "+++ %s Activated! +++"
local rsa_buff_fade = "+++ %s has Ended! +++"
local rsa_debuff_cast = "+++ %s has saved my life, You fail Healers! +++"
local rsa_debuff_fade = "+++ %s is active again! +++" 

--[[ Slash Command Localisation ]]--
local rsa_slash_invalid = " is not a valid command. Valid commands are: on, off, channel, target." -- FINISH ME!
local rsa_slash_on = "Enabled."
local rsa_slash_off = "Disabled, RSA will no longer announce anything."
local rsa_slash_remove = "%s Removed."
local rsa_slash_add = "%s Added."
local rsa_slash_channel_empty = "|cFFFF75B3[|rChannel|cFFFF75B3]|r - Change the name of the custom announcement channel. Current channel is set to: |cFFFF75B3"
local rsa_slash_add_info = "Commands are: add target SPELLID, add self SPELLID."
local rsa_slash_basic = "Commands are: on, off, channel, target."

--[[
local L = GetLocale()
if L == "frFR" then
local rsa_fail_invalid = ""
blah blah ... copy all variables in localisation and edit as appropriate.
end ]]--

--[[ Register Print function for slash commands ]]--
local function Print(msg)
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r "..msg)
end

--[[ Register Send Chat message commands ]]--
-- Whisper Target
local function Whisper()
SendChatMessage(format(rsa_spell_cast, info) .. "You", "WHISPER", nil, whispertarget)
end

-- Whisper Target for Self End - Why? Fuck knows, but to stop errors because I cba to put in proper checks to disable this sort of thing. Not yet at least.
local function WhisperEnd()
SendChatMessage(format(rsa_spell_fade, info), "WHISPER", nil, UnitName(rsa_self))
end

-- Whisper Target for Self  AD End - Why? Fuck knows, but to stop errors because I cba to put in proper checks to disable this sort of thing. Not yet at least.
local function WhisperADEnd()
SendChatMessage(format(rsa_debuff_fade, info), "WHISPER", nil, UnitName(rsa_self))
end

-- Whisper Target for Self  AD Start - Why? Fuck knows, but to stop errors because I cba to put in proper checks to disable this sort of thing. Not yet at least.
local function WhisperADStart()
SendChatMessage(format(rsa_debuff_cast, info), "WHISPER", nil, UnitName(rsa_self))
end

-- Raid/Party on Target
local function RPTar()
if GetNumRaidMembers()>0 then
	SendChatMessage(format(rsa_spell_cast, info) .. whispertarget, "RAID", nil)
elseif GetNumPartyMembers()>0 then
	SendChatMessage(format(rsa_spell_cast, info) .. whispertarget, "PARTY", nil)
end
end

-- Raid/Party on Self
local function RPSelf()
if GetNumRaidMembers()>0 then
	SendChatMessage(format(rsa_buff_cast, info), "RAID", nil)
elseif GetNumPartyMembers()>0 then
	SendChatMessage(format(rsa_buff_cast, info), "PARTY", nil)
end
end

-- Raid/Party on Self End
local function RPSelfEnd()
if GetNumRaidMembers()>0 then
	SendChatMessage(format(rsa_buff_fade, info), "RAID", nil)
elseif GetNumPartyMembers()>0 then
	SendChatMessage(format(rsa_buff_fade, info), "PARTY", nil)
end
end

-- Raid/Party on Self End AD
local function RPADEnd()
if GetNumRaidMembers()>0 then
	SendChatMessage(format(rsa_debuff_fade, info), "RAID", nil)
elseif GetNumPartyMembers()>0 then
	SendChatMessage(format(rsa_debuff_fade, info), "PARTY", nil)
end
end

-- Raid/Party on Self Start AD
local function RPADStart()
if GetNumRaidMembers()>0 then
	SendChatMessage(format(rsa_debuff_cast, info), "RAID", nil)
elseif GetNumPartyMembers()>0 then
	SendChatMessage(format(rsa_debuff_cast, info), "PARTY", nil)
end
end

-- Custom Channel on Target
local function ChannelTar()
SendChatMessage(format(rsa_spell_cast, info) .. whispertarget, "CHANNEL", nil, GetChannelName(_G.RSA_CHAN))
end

-- Custom Channel on Self
local function ChannelSelf()
SendChatMessage(format(rsa_buff_cast, info), "CHANNEL", nil, GetChannelName(_G.RSA_CHAN))
end

-- Custom Channel on Self End
local function ChannelSelfEnd()
SendChatMessage(format(rsa_buff_fade, info), "CHANNEL", nil, GetChannelName(_G.RSA_CHAN))
end

-- Custom Channel on Self End AD
local function ChannelADEnd()
SendChatMessage(format(rsa_debuff_fade, info), "CHANNEL", nil, GetChannelName(_G.RSA_CHAN))
end

-- Custom Channel on Self Start AD
local function ChannelADStart()
SendChatMessage(format(rsa_debuff_cast, info), "CHANNEL", nil, GetChannelName(_G.RSA_CHAN))
end

-- Print to Self for Target
local function PrintSelfTar()
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(rsa_spell_cast, info) .. whispertarget, RWColor)
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(rsa_spell_cast, info) .. whispertarget)
end

-- Print to Self for Self
local function PrintSelf()
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(rsa_buff_cast, info), RWColor)
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(rsa_buff_cast, info))
end

-- Print to Self for Self End
local function PrintSelfEnd()
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(rsa_buff_fade, info), RWColor)
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(rsa_buff_fade, info))
end

-- Print to Self for Self AD End
local function PrintADEnd()
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(rsa_debuff_fade, info), RWColor)
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(rsa_debuff_fade, info))
end

-- Print to Self for Self AD Start
local function PrintADStart()
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(rsa_debuff_cast, info), RWColor)
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(rsa_debuff_cast, info))
end


-- Set default custom channel
if _G["RSA_CHAN"] == "" or _G["RSA_CHAN"] == nil then
	_G["RSA_CHAN"] = "ambipallys"
end


if type (_G["RSA_SPELL_AD"]) ~="table" then
	_G["RSA_SPELL_AD"] = {}
--	_G["RSA_SPELL_AD"][20217] = {} -- Blessing of Kints for Testing
--	_G["RSA_SPELL_AD"][20217]["1234"] = true
	
	_G["RSA_SPELL_AD"][66233] = {} -- Ardent Defender
	_G["RSA_SPELL_AD"][66233]["23"] = true
end

-- Set default spells and announcement channels for targetted spells.
if type (_G["RSA_SPELL_TARGET"]) ~="table" then
	_G["RSA_SPELL_TARGET"] = {}
--	_G["RSA_SPELL_TARGET"][20217] = {} -- Blessing of Kings for Testing
--	_G["RSA_SPELL_TARGET"][20217]["1234"] = true
	
	_G["RSA_SPELL_TARGET"][1022] = {} -- Hand of Protection Rank 1
	_G["RSA_SPELL_TARGET"][1022]["13"] = true
	
	_G["RSA_SPELL_TARGET"][5599] = {} -- Hand of Protection Rank 2
	_G["RSA_SPELL_TARGET"][5599]["13"] = true
	
	_G["RSA_SPELL_TARGET"][10278] = {} -- Hand of Protection Rank 3
	_G["RSA_SPELL_TARGET"][10278]["13"] = true
	
	_G["RSA_SPELL_TARGET"][6940] = {} -- Hand of Sacrifice
	_G["RSA_SPELL_TARGET"][6940]["13"] = true
	
	_G["RSA_SPELL_TARGET"][1038] = {} -- Hand of Salvation
	_G["RSA_SPELL_TARGET"][1038]["13"] = true
	
	_G["RSA_SPELL_TARGET"][1044] = {} -- Hand of Freedom
	_G["RSA_SPELL_TARGET"][1044]["13"] = true
	
	_G["RSA_SPELL_TARGET"][19752] = {} -- Divine Intervention
	_G["RSA_SPELL_TARGET"][19752]["12"] = true	
	
-- [[ Add other class spells ]] --

	_G["RSA_SPELL_TARGET"][47788] = {} -- Guardian Spirit
	_G["RSA_SPELL_TARGET"][47788]["123"] = true
	
	_G["RSA_SPELL_TARGET"][33206] = {} -- Pain Suppression
	_G["RSA_SPELL_TARGET"][33206]["123"] = true

	_G["RSA_SPELL_TARGET"][29166] = {} -- Innervate
	_G["RSA_SPELL_TARGET"][29166]["13"] = true

	_G["RSA_SPELL_TARGET"][48477] = {} -- Rebirth
	_G["RSA_SPELL_TARGET"][48477]["12"] = true		
end

-- Set default spells and announcement channels for self cast spells.
if type (_G["RSA_SPELL_SELF"]) ~="table" then
	_G["RSA_SPELL_SELF"] = {}
--	_G["RSA_SPELL_SELF"][20217] = {} -- Blessing of Kings for Testing
--	_G["RSA_SPELL_SELF"][20217]["1234"] = true
	
	_G["RSA_SPELL_SELF"][64205] = {} -- Divine Sacrifice
	_G["RSA_SPELL_SELF"][64205]["23"] = true
	
	_G["RSA_SPELL_SELF"][498] = {} -- Divine Protection
	_G["RSA_SPELL_SELF"][498]["23"] = true
	
	_G["RSA_SPELL_SELF"][25771] = {} -- Forbearance
	_G["RSA_SPELL_SELF"][25771]["4"] = true
	
	_G["RSA_SPELL_SELF"][54428] = {} -- Divine Plea
	_G["RSA_SPELL_SELF"][54428]["4"] = true	
	
	

end




local spellevents = {
	SPELL_CAST_SUCCESS = true,
	SPELL_HEAL = true,
	SPELL_SUMMON = true,
	}

local selfauraevents = {
	SPELL_AURA_APPLIED = true,
	}
	
local selfauraeventsend = {
	SPELL_AURA_REMOVED = true,
	}	
	

local frame = CreateFrame("Frame", "RSA_FRAME")
frame:SetScript("OnEvent", function(_, _, _, event, _, source, _, _, dest, _, spellID)	
	if source == UnitName(rsa_self) then
-- Check if the spell being cast is a self cast, and it's on the list of self only spells. For testing, using the same spell table as above.
		if selfauraevents[event] then
			if dest == UnitName(rsa_self) and _G["RSA_SPELL_SELF"][spellID] then
				if	_G["RSA_SPELL_SELF"][spellID]["1"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()					
				elseif _G["RSA_SPELL_SELF"][spellID]["2"] then
					info = GetSpellInfo(spellID)
					RPSelf()				
				elseif	_G["RSA_SPELL_SELF"][spellID]["3"] then
					info = GetSpellInfo(spellID)
					ChannelSelf()
				elseif	_G["RSA_SPELL_SELF"][spellID]["4"] then
					info = GetSpellInfo(spellID)
					PrintSelf()			
				elseif	_G["RSA_SPELL_SELF"][spellID]["12"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()
					RPSelf()
				elseif	_G["RSA_SPELL_SELF"][spellID]["13"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()
					ChannelSelf()
				elseif	_G["RSA_SPELL_SELF"][spellID]["14"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()
					PrintSelf()
				elseif	_G["RSA_SPELL_SELF"][spellID]["123"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()
					RPSelf()
					ChannelSelf()
				elseif	_G["RSA_SPELL_SELF"][spellID]["124"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()
					RPSelf()
					PrintSelf()
				elseif	_G["RSA_SPELL_SELF"][spellID]["1234"] then
					info = GetSpellInfo(spellID)	
					whispertarget = dest
					Whisper()
					RPSelf()
					ChannelSelf()
					PrintSelf()
				elseif _G["RSA_SPELL_SELF"][spellID]["23"] then
					info = GetSpellInfo(spellID)	
					RPSelf()
					ChannelSelf()
				elseif _G["RSA_SPELL_SELF"][spellID]["24"] then
					info = GetSpellInfo(spellID)				
					RPSelf()
					PrintSelf()
				elseif _G["RSA_SPELL_SELF"][spellID]["234"] then
					info = GetSpellInfo(spellID)				
					RPSelf()
					ChannelSelf()
					PrintSelf()
				elseif _G["RSA_SPELL_SELF"][spellID]["34"] then
					info = GetSpellInfo(spellID)
					ChannelSelf()
					PrintSelf()				
				end
-- Ardent Defender				
			elseif dest == UnitName(rsa_self) and _G["RSA_SPELL_AD"][spellID] then
				if	_G["RSA_SPELL_AD"][spellID]["1"] then
					info = GetSpellInfo(spellID)
					WhisperADStart()					
				elseif _G["RSA_SPELL_AD"][spellID]["2"] then
					info = GetSpellInfo(spellID)
					RPADStart()				
				elseif	_G["RSA_SPELL_AD"][spellID]["3"] then
					info = GetSpellInfo(spellID)
					ChannelADStart()
				elseif	_G["RSA_SPELL_AD"][spellID]["4"] then
					info = GetSpellInfo(spellID)
					PrintADStart()			
				elseif	_G["RSA_SPELL_AD"][spellID]["12"] then
					info = GetSpellInfo(spellID)
					WhisperADStart()
					RPADStart()
				elseif	_G["RSA_SPELL_AD"][spellID]["13"] then
					info = GetSpellInfo(spellID)
					WhisperADStart()
					ChannelADStart()
				elseif	_G["RSA_SPELL_AD"][spellID]["14"] then
					info = GetSpellInfo(spellID)
					WhisperADStart()
					PrintADStart()
				elseif	_G["RSA_SPELL_AD"][spellID]["123"] then
					info = GetSpellInfo(spellID)
					WhisperADStart()
					RPADStart()
					ChannelADStart()
				elseif	_G["RSA_SPELL_AD"][spellID]["124"] then
					info = GetSpellInfo(spellID)			
					WhisperADStart()
					RPADStart()
					PrintADStart()
				elseif	_G["RSA_SPELL_AD"][spellID]["1234"] then
					info = GetSpellInfo(spellID)					
					WhisperADStart()
					RPADStart()
					ChannelADStart()
					PrintADStart()
				elseif _G["RSA_SPELL_AD"][spellID]["23"] then
					info = GetSpellInfo(spellID)	
					RPADStart()
					ChannelADStart()
				elseif _G["RSA_SPELL_AD"][spellID]["24"] then
					info = GetSpellInfo(spellID)				
					RPADStart()
					PrintADStart()
				elseif _G["RSA_SPELL_AD"][spellID]["234"] then
					info = GetSpellInfo(spellID)				
					RPADStart()
					ChannelADStart()
					PrintADStart()
				elseif _G["RSA_SPELL_AD"][spellID]["34"] then
					info = GetSpellInfo(spellID)
					ChannelADStart()
					PrintADStart()				
				end				
			end
-- Check if the self cast spell has finished and announce.
		elseif selfauraeventsend[event] then
			if dest == UnitName(rsa_self) and _G["RSA_SPELL_SELF"][spellID] then
				if	_G["RSA_SPELL_SELF"][spellID]["1"] then
					info = GetSpellInfo(spellID)
					WhisperEnd()					
				elseif _G["RSA_SPELL_SELF"][spellID]["2"] then
					info = GetSpellInfo(spellID)
					RPSelfEnd()				
				elseif	_G["RSA_SPELL_SELF"][spellID]["3"] then
					info = GetSpellInfo(spellID)
					ChannelSelfEnd()
				elseif	_G["RSA_SPELL_SELF"][spellID]["4"] then
					info = GetSpellInfo(spellID)
					PrintSelfEnd()			
				elseif	_G["RSA_SPELL_SELF"][spellID]["12"] then
					info = GetSpellInfo(spellID)
					WhisperEnd()
					RPSelfEnd()
				elseif	_G["RSA_SPELL_SELF"][spellID]["13"] then
					info = GetSpellInfo(spellID)
					WhisperEnd()
					ChannelSelfEnd()
				elseif	_G["RSA_SPELL_SELF"][spellID]["14"] then
					info = GetSpellInfo(spellID)
					WhisperEnd()
					PrintSelfEnd()
				elseif	_G["RSA_SPELL_SELF"][spellID]["123"] then
					info = GetSpellInfo(spellID)
					WhisperEnd()
					RPSelfEnd()
					ChannelSelfEnd()
				elseif	_G["RSA_SPELL_SELF"][spellID]["124"] then
					info = GetSpellInfo(spellID)			
					WhisperEnd()
					RPSelfEnd()
					PrintSelfEnd()
				elseif	_G["RSA_SPELL_SELF"][spellID]["1234"] then
					info = GetSpellInfo(spellID)					
					WhisperEnd()
					RPSelfEnd()
					ChannelSelfEnd()
					PrintSelfEnd()
				elseif _G["RSA_SPELL_SELF"][spellID]["23"] then
					info = GetSpellInfo(spellID)	
					RPSelfEnd()
					ChannelSelfEnd()
				elseif _G["RSA_SPELL_SELF"][spellID]["24"] then
					info = GetSpellInfo(spellID)				
					RPSelfEnd()
					PrintSelfEnd()
				elseif _G["RSA_SPELL_SELF"][spellID]["234"] then
					info = GetSpellInfo(spellID)				
					RPSelfEnd()
					ChannelSelfEnd()
					PrintSelfEnd()
				elseif _G["RSA_SPELL_SELF"][spellID]["34"] then
					info = GetSpellInfo(spellID)
					ChannelSelfEnd()
					PrintSelfEnd()				
				end				
-- Ardent Defender
			elseif dest == UnitName(rsa_self) and _G["RSA_SPELL_AD"][spellID] then
				if	_G["RSA_SPELL_AD"][spellID]["1"] then
					info = GetSpellInfo(spellID)
					WhisperADEnd()					
				elseif _G["RSA_SPELL_AD"][spellID]["2"] then
					info = GetSpellInfo(spellID)
					RPADEnd()				
				elseif	_G["RSA_SPELL_AD"][spellID]["3"] then
					info = GetSpellInfo(spellID)
					ChannelADEnd()
				elseif	_G["RSA_SPELL_AD"][spellID]["4"] then
					info = GetSpellInfo(spellID)
					PrintADEnd()			
				elseif	_G["RSA_SPELL_AD"][spellID]["12"] then
					info = GetSpellInfo(spellID)
					WhisperADEnd()
					RPADEnd()
				elseif	_G["RSA_SPELL_AD"][spellID]["13"] then
					info = GetSpellInfo(spellID)
					WhisperADEnd()
					ChannelADEnd()
				elseif	_G["RSA_SPELL_AD"][spellID]["14"] then
					info = GetSpellInfo(spellID)
					WhisperADEnd()
					PrintADEnd()
				elseif	_G["RSA_SPELL_AD"][spellID]["123"] then
					info = GetSpellInfo(spellID)
					WhisperADEnd()
					RPADEnd()
					ChannelADEnd()
				elseif	_G["RSA_SPELL_AD"][spellID]["124"] then
					info = GetSpellInfo(spellID)			
					WhisperADEnd()
					RPADEnd()
					PrintADEnd()
				elseif	_G["RSA_SPELL_AD"][spellID]["1234"] then
					info = GetSpellInfo(spellID)					
					WhisperADEnd()
					RPADEnd()
					ChannelADEnd()
					PrintADEnd()
				elseif _G["RSA_SPELL_AD"][spellID]["23"] then
					info = GetSpellInfo(spellID)	
					RPADEnd()
					ChannelADEnd()
				elseif _G["RSA_SPELL_AD"][spellID]["24"] then
					info = GetSpellInfo(spellID)				
					RPADEnd()
					PrintADEnd()
				elseif _G["RSA_SPELL_AD"][spellID]["234"] then
					info = GetSpellInfo(spellID)				
					RPADEnd()
					ChannelADEnd()
					PrintADEnd()
				elseif _G["RSA_SPELL_AD"][spellID]["34"] then
					info = GetSpellInfo(spellID)
					ChannelADEnd()
					PrintADEnd()				
				end			
			end			
-- Check if the spell being cast is not a self cast, and it's on the list of targetted spells.		
		elseif spellevents[event] and dest ~= UnitName(rsa_self)then
		if _G["RSA_SPELL_TARGET"][spellID] then
			if dest == UnitName(rsa_target) or dest == UnitName(rsa_mouseover) or dest == UnitName (rsa_focus) then
				if	_G["RSA_SPELL_TARGET"][spellID]["1"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest
					Whisper()					
				elseif _G["RSA_SPELL_TARGET"][spellID]["2"] then
					info = GetSpellInfo(spellID)
					RPTar()				
				elseif	_G["RSA_SPELL_TARGET"][spellID]["3"] then
					info = GetSpellInfo(spellID)
					ChannelTar()
				elseif	_G["RSA_SPELL_TARGET"][spellID]["4"] then
					info = GetSpellInfo(spellID)
					PrintSelfTar()			
				elseif	_G["RSA_SPELL_TARGET"][spellID]["12"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest					
					Whisper()
					RPTar()
				elseif	_G["RSA_SPELL_TARGET"][spellID]["13"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest					
					Whisper()
					ChannelTar()
				elseif	_G["RSA_SPELL_TARGET"][spellID]["14"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest					
					Whisper()
					PrintSelfTar()
				elseif	_G["RSA_SPELL_TARGET"][spellID]["123"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest					
					Whisper()
					RPTar()
					ChannelTar()
				elseif	_G["RSA_SPELL_TARGET"][spellID]["124"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest					
					Whisper()
					RPTar()
					PrintSelfTar()
				elseif	_G["RSA_SPELL_TARGET"][spellID]["1234"] then
					info = GetSpellInfo(spellID)
					whispertarget = dest					
					Whisper()
					RPTar()
					ChannelTar()
					PrintSelfTar()
				elseif _G["RSA_SPELL_TARGET"][spellID]["23"] then
					info = GetSpellInfo(spellID)	
					RPTar()
					ChannelTar()
				elseif _G["RSA_SPELL_TARGET"][spellID]["24"] then
					info = GetSpellInfo(spellID)				
					RPTar()
					PrintSelfTar()
				elseif _G["RSA_SPELL_TARGET"][spellID]["234"] then
					info = GetSpellInfo(spellID)				
					RPTar()
					ChannelTar()
					PrintSelfTar()
				elseif _G["RSA_SPELL_TARGET"][spellID]["34"] then
					info = GetSpellInfo(spellID)
					ChannelTar()
					PrintSelfTar()				
				end
			end
		end
		end	
	end
end)

--[[ The following commented area runs a check to see if the saved channel is party raid or whisper, 
	 and if you are in a party or raid it will send it there. This does not employ enough checks, and therefore I will use
	 the one after this ]]--
--	if spellevents[event] and source == UnitName(rsa_self) and dest ~= UnitName(rsa_self) and _G.RSA_SPELL[spellID] then
--		for chan in pairs(_G["RSA_SPELL_TARGET"][spellID]) do
--			if (chan == "RAID" and GetNumRaidMembers()>0) or (chan == "PARTY" and GetNumPartyMembers()>0) or (chan == "WHISPER") then 
--				local info = GetSpellInfo(spellID)
--				SendChatMessage(format(rsa_spell_cast,info) .. UnitName(_G.RSA_TARGET), chan, nil, UnitName(_G.RSA_TARGET));
--			end
--		end
-- [[ End of code that Funky Helped with. ]]--




			--[[
				if _G["RSA_SPELL_TARGET"][spellID]["PARTY"] or _G["RSA_SPELL_TARGET"][spellID]["RAID"] then
					local info = GetSpellInfo(spellID)
					if GetNumRaidMembers()>0 then
						SendChatMessage(format(rsa_buff_cast, info), "RAID", nil)
					elseif GetNumPartyMembers()>0 then
						SendChatMessage(format(rsa_buff_cast, info), "PARTY", nil)
					end	
				elseif _G["RSA_SPELL_TARGET"][spellID]["CHANNEL"] then
				local info = GetSpellInfo(spellID)
					SendChatMessage(format(rsa_buff_cast,n), "CHANNEL", nil, GetChannelName(_G.RSA_Chan))				
			end ]]--	
	
--	if spellevents[event] and source == UnitName(rsa_self) and dest ~= UnitName(rsa_self) and _G.RSA_SPELL[spellID] and _G.RSA_SPELL[spellID]["WHISPER"] then
--	Print("test")
	
		

	



frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")





--[[ Register the slash commands ]]--
SLASH_RSASLASH1, SLASH_RSASLASH2 = "/rsa";
local function slashcmdhandler(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	if command == "channel" and rest ~= "" then
			_G["RSA_CHAN"] = rest
			Print("Custom channel updated to|cFFFF75B3 " .. rest .. "|r")
	elseif command == "channel" and rest == "" then
			Print(rest .. rsa_slash_channel_empty .. _G["RSA_CHAN"] .. "|r.")
--	elseif command == "add" and rest ~="target" or rest ~="self" then
--			Print(rest .. rsa_slash_add_info)
--	elseif command =="add target" and rest ~=""then
--			_G["RSA_SPELL_TARGET"][rest] = true
--			print(rest .. "added")
	elseif command == "config" then
		 InterfaceOptionsFrame_OpenToCategory(RSAPanel);
	elseif command == "" then
			Print(rsa_slash_basic)
	elseif command == "on" and rest == "" then
			_G["RSA_OFF"] = nil
			Print(rsa_slash_on)
	elseif command == "off" and rest == "" then
			_G["RSA_OFF"] = true
			Print(rsa_slash_off)
	elseif command ~="channel" or command ~="off" or command ~="on" or command ~="target" then
			Print(msg .. rsa_slash_invalid)
	end
end
SlashCmdList["RSASLASH"] = slashcmdhandler;